<?php
require_once "common.inc.php";

// Variabili d'esempio, queste normalmente arriverebbero da un database, dopo aver fatto il login
$user_id = 1337;
$user_secret = 'mysecret';

function json_rpc_call($url, $method, $params=null) {
	global $user_id, $user_secret;

	$request = array(
		'method' => $method,
		'id' => 1
	);
	if (is_array($params))
		$request['params'] = $params;
	$request = json_encode($request);

	$hmac = hash_hmac('sha1', $request, $user_secret);
	$hmac = base64_encode($hmac);

	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array(
		"Authentication: AuthHMAC $user_id:$hmac",
		'Content-Type: application/json',
		'Content-Length: ' . strlen($request) . "\r\n",
		$request
	));
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$output = curl_exec($ch);
	curl_close($ch);

	$output = json_decode($output, true);

	if (!is_null($output['error']))
		throw new Exception($output['error']['message']);

	return $output['result'];
}

try {
	var_dump( json_rpc_call("http://localhost/hmac/json-rpc.php", "get") );
	var_dump( json_rpc_call("http://localhost/hmac/json-rpc.php", "set", array("Nuovo titolo", "17/01/2011", "Nuovo testo dell'articolo")) );
	var_dump( json_rpc_call("http://localhost/hmac/json-rpc.php", "get") );
} catch (Exception $e) {
	echo "JSON-RPC call failed with message: {$e->getMessage()}";
}

