<?php
if (!function_exists('hash_hmac')) {
	function hash_hmac($hashfunc, $data, $key) {
		$blocksize = 64;
		if (strlen($key) > $blocksize)
			$key = pack('H*', $hashfunc($key));
		$key = str_pad($key, $blocksize, chr(0x00));
		$ipad = str_repeat(chr(0x36), $blocksize) ^ $key;
		$opad = str_repeat(chr(0x5C), $blocksize) ^ $key;

		$hmac = pack('H*', $hashfunc( $opad.pack('H*', $hashfunc($ipad.$data)) ));
		return bin2hex($hmac);
	}
}