<?php
// Inizializzo l'ambiente caricando lo zend framework
error_reporting(E_ALL);
require_once "ZendFramework/Zend/Loader.php";

$includes = get_included_files();
set_include_path( dirname(dirname($includes[ count($includes)-1 ])) . PATH_SEPARATOR . get_include_path() );
unset($includes);

Zend_Loader::loadClass("Zend_Loader_Autoloader");
Zend_Loader_Autoloader::getInstance();

require_once "common.inc.php";

// Definisco la classe che legge e scrive il file con l'articolo
class ArticleUpdater {
	protected static $storage = 'article.json';

	public function set($title, $date, $content) {
		file_put_contents(self::$storage, json_encode(array(
			'title' => $title,
			'date' => $date,
			'content' => $content
		)));
	}

	public function get() {
		return json_decode(file_get_contents(self::$storage), true);
	}
}

// Server JSON
$server = new Zend_Json_Server();
$server->setClass('ArticleUpdater');

if ($_SERVER['REQUEST_METHOD'] == 'GET') {
	$server->setTarget('/json-rpc.php')
	       ->setEnvelope(Zend_Json_Server_Smd::ENV_JSONRPC_2);

	header('Content-Type: application/json');
	echo $server->getServiceMap();
	return;
}

// Header Authentication obbligatorio
if (empty($_SERVER['HTTP_AUTHENTICATION']) || strpos($_SERVER['HTTP_AUTHENTICATION'], 'AuthHMAC ') !== 0)
	die("AUTHENTICATION FAILED");

// Separo l'id utente dal codice hmac e lo decodifico da base64
list($user_id, $hmac) = explode(':', substr($_SERVER['HTTP_AUTHENTICATION'], 9));
$hmac = base64_decode($hmac);

function get_secret_by_user($user_id) {
	// normalmente interrogherebbe il database, ma saltiamo l'implementazione che non ci interessa
	if ($user_id == '1337')
		return 'mysecret';
	else
		return '';
}

// Ricalcolo l'hmac e lo confronto con quello associato alla richiesta
if ( hash_hmac('sha1', file_get_contents("php://input"), get_secret_by_user($user_id)) != $hmac )
	die("AUTHENTICATION FAILED");

// Elabora richiesta JSON-RPC
$server->handle();
